#!/usr/bin/python

# Import the CGI module
import cgi
import os
import string

# Required header that tells the browser how to render the HTML.
print "Content-Type: text/html\n\n"

# Define function to generate HTML form.

def print_form(query=None):
    print "\t\t<FORM METHOD = get ACTION =\"guisearch.cgi\">\n"
    print "\t<TABLE BORDER = 0>\n"


    if (query==None): 
        print "\t\t<TR><TH>Search:</TH><TD><INPUT type = text name = \"query\"></TD>" 
    else: 
        print "\t\t<TR><TH>Search:</TH><TD><INPUT type = text name = \"query\" value =\"%s\"></TD>" %query 

    print "<Td><INPUT TYPE = submit VALUE = \"Enter\"></TD></TR>\n"

    print "<HR>\t</TABLE>\n"
    print "\t</FORM>\n"    
     

def generate_form():
    print "<HTML>\n"
    print "<HEAD>\n"
    print "\t<TITLE>GUISearch</TITLE>\n"
    print "</HEAD>\n"
    print "<BODY BGCOLOR = white>\n"
    print "<img alt=\"GUISearch\" src=\"guisearch.jpg\"> <B>KDE DB</B><BR>"
    print """
<A HREF="http://guisearch.sourceforge.net">http://guisearch.sourceforge.net</A>
<BR>
<BR>
Sample queries:
<UL>
<LI> send (search for send in all applications)
<LI> in:kmail (browse kmail code)
<LI> message in:kmail (search in kmail only)
<LI> table
<LI> page
<LI> undo (equivalent to "undo in:all")
<LI> drag drop in:koffice
<LI> newsgroups in:knode (equivalent to "newsgroups in:kdenetwork/knode")
<LI> in:knode (browse knode code)
<LI> in:all (browse all KDE code; <i>very</i> slow right now)
</UL>
When you enter a query, GUISearch will return matching GUI messages and/or functions.
For a GUI message, click on source to see the connection between the GUI message
and its callback; click on functions to see the GUI message's callback and functions
it calls.  For a function, click on source to see its source; click on GUI messages
to see GUI messages whose callbacks are either the function itself or that call
the function directly/indirectly.
<P>
As this tool is rather unconventional, we recommend that you read our paper first 
[ <A HREF="http://www.cse.unsw.edu.au/~amichail/guisearch.pdf">pdf</A> / <A HREF="http://www.cse.unsw.edu.au/~amichail/guisearch.ps.gz">ps.gz</A> ].
"""


    print_form()

    print "</BODY>\n"
    print "</HTML>\n"

    # Define function display data.
def display_data(query): # yes/no for stem
    print "<HTML>\n"
    print "<img alt=\"GUISearch\" src=\"guisearch.jpg\"> <B>KDE DB</B><BR>"
    #print "<font size=2><I>Note:  Clicking on source beside a GUI message shows you where a connection is made between that GUI message and its callback; to see the source of the callback itself, you need to click on functions first to see the callback (with depth 0) and then click on its source link.</I></font>"
    print_form(query)

    os.system("rm results")

    query = string.replace(query,">","\>")
    query = string.replace(query,"(","\(")
    query = string.replace(query,")","\)")
    query = string.replace(query,"'","\\'")

#        print query + "<BR>"
        
    os.system("./guisearch/query.py " +" " + query + "> results")


    try:
        f = open( "results", "r")
        text = f.read()
        f.close()
        print text
    except IOError:
        print "Couldn't get back results from search"


        
    print "</BODY>\n"
    print "</HTML>\n"

    # Define main function.
def main():
    form = cgi.FieldStorage()
    msg = "-"
    query = ""
    if form.has_key("query"):
        query = form["query"].value
        display_data(query)
    else:
        generate_form()

    # Call main function.

main()
